/* Programma che risolve equazioni di primo e secondo grado
   Versione con funzioni */

#include<stdio.h>
#include<math.h>
#include<stdlib.h>

double gr1(double a, double b)                   //funzione per il calcolo del primo grado
{
	double x;
	if(a == 0)                          //controllo CE
	{
		printf("Nessuna soluzione\n");
		exit(-1);                       //termino il programma
	}
	else
	{
		x = -b/a;
		return x;
	}
}


double delta(double a, double b, double c)
{
	return (b*b - 4*a*c);
}


void gr2(double a, double b, double c, double*y1, double*y2)
{
	double del;
	del = delta(a, b, c);
	if(del < 0)      //controllo delta
	{
		printf("Nessuna soluzione reale\n");
		exit(-1);
	}
	else
	{
		*y1 = (-b + sqrt(del))/(2*a);         //calcolo delle 2 soluzioni
		*y2 = (-b - sqrt(del))/(2*a);
	}
}


int main()
{
	char grado[2];
	int opt;
	double c1, c2, c3, x1, x2;
	printf("Dichiarare il grado dell'equazione (1 o 2):\n");
	fgets(grado, sizeof(grado), stdin);      //selezione dell'ordine dell'equazione
	opt = atoi(grado);
	switch(opt)
	{

		case 1 :            //acquisizione e risoluzione dell'equazione di 1 grado
		{
			printf("Inserire i coefficienti dell'equazione di primo grado (ax + b = 0):\n");
			scanf("%lf %lf", &c1, &c2);
			x1 = gr1(c1, c2);
			printf("x = %lf\n", x1);
			break;             //fine 1 grado
		}

		case 2 :             //acquisizione e risoluzione dell'equazione di 2 grado
		{
			printf("Inserire i coefficienti dell'equazione di secondo grado (ax^2 + bx + c = 0):\n");
			scanf("%lf %lf %lf", &c1, &c2, &c3);
			gr2(c1, c2, c3,&x1, &x2);
			printf("Le soluzioni sono:\nx1 = %lf\nx2 = %lf\n", x1, x2);
			break;             //fine 2 grado
		}
	}
	return 0;
}
