/* Testo.c: troca le vocali della divina commedia*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#define NUMVOC 5
#define NUMLETT 26


void contavocali();
void contalettere();
int char2index( int c);


int main()
{
	/* contavocali(); */   /*commento perch voglio usare l'altra funzione*/
	contalettere();
	return 0;
}



void contavocali()
{
	int vocali[NUMVOC]={0};     /*inizializzazione vettore*/
	int c;
	int i;
	char lettere[NUMVOC]={'A', 'E', 'I', 'O', 'U'};
	
	/* Il ciclo continua a leggere dei caratteri finch non arriva alla fine del file.
	   La funzione passa automaticamente al carattere successivo.*/
	while((c=fgetc(stdin)) != EOF)
	{
		c=tolower(c);
		switch(c)
		{
			case 'a':
				vocali[0]++;
				break;
			case 'e':
				vocali[1]++;
				break;
			case 'i':
				vocali[2]++;
				break;
			case 'o':
				vocali[3]++;
				break;
			case 'u':
				vocali[4]++;
				break;
		}	
	}
	for(i=0; i<NUMVOC; i++)
	{
		printf("%c --> %i\n", lettere[i], vocali[i]);
	}
}	



void contalettere()
{
	int lettere[NUMLETT] = {0};
	int i, c, totlett=0;
	
	/* Il ciclo funziona come prima */
	while((c=fgetc(stdin)) != EOF)
	{
		int index = char2index(c);   /*la funzione assegna numeri crescenti a lettere crescenti*/
		if(index >= 0)
		{
			lettere[index] ++;
			totlett ++;
		}
	}
	
	/* Stampo le informazioni */
	printf("Il totale delle lettere e': %i\n", totlett);
	for(i = 0; i < NUMLETT; i++)
	{
		printf("%c --> %i\t%.2f%%\n",'a' + i, lettere[i], (float) lettere[i] / totlett * 100);
	}
}	
/* I due "%" servono per stampare il carattere, che altrimenti verrebbe interpertato come segnaposto.
   Il (float) serve per forzare a numero decimale la divisione tra interi.
  'a' viene interpretato come un valore char. 'a' + 1 significa 'b' per il computer.
   "\t si usa per stampare una tabulazione*/
	
	
int char2index( int c)
{
	c = tolower(c);
	if(c>='a' && c<='z')
	{
		return c - 'a';
	}
	return -1;
}
/* I caratteri sono numeri interi interi, le lettere in particolare sono sequenziali.
   Per questo nella funzione li tratto come numeri interi: il parametro c e' un int.*/
	
	
